diff --git a/tests/CMakeLists.txt b/tests/CMakeLists.txt
new file mode 100644
index 000000000000..f1ba542fab90
--- /dev/null
+++ b/tests/CMakeLists.txt
@@ -0,0 +1,14 @@
+# SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
+# Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file
+
+rdma_python_test(tests
+  __init__.py
+  test_addr.py
+  base.py
+  test_cq.py
+  test_device.py
+  test_mr.py
+  test_pd.py
+  test_qp.py
+  utils.py
+  )
diff --git a/pyverbs/tests/__init__.py b/tests/__init__.py
similarity index 100%
rename from pyverbs/tests/__init__.py
rename to tests/__init__.py
diff --git a/pyverbs/tests/base.py b/tests/base.py
similarity index 100%
rename from pyverbs/tests/base.py
rename to tests/base.py
diff --git a/pyverbs/tests/addr.py b/tests/test_addr.py
similarity index 98%
rename from pyverbs/tests/addr.py
rename to tests/test_addr.py
index 1c56f56bd0bd..9cc801226e69 100644
--- a/pyverbs/tests/addr.py
+++ b/tests/test_addr.py
@@ -1,9 +1,9 @@
 # SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
 # Copyright (c) 2019 Mellanox Technologies, Inc. All rights reserved.  See COPYING file
 
-from pyverbs.tests.base import PyverbsAPITestCase
 from pyverbs.addr import GlobalRoute, AHAttr, AH
 from pyverbs.pyverbs_error import PyverbsError
+from tests.base import PyverbsAPITestCase
 import pyverbs.device as d
 import pyverbs.enums as e
 from pyverbs.pd import PD
diff --git a/pyverbs/tests/cq.py b/tests/test_cq.py
similarity index 98%
rename from pyverbs/tests/cq.py
rename to tests/test_cq.py
index e1e56d363011..7848f39c9c63 100644
--- a/pyverbs/tests/cq.py
+++ b/tests/test_cq.py
@@ -7,9 +7,9 @@ import random
 
 from pyverbs.cq import CompChannel, CQ, CqInitAttrEx, CQEX
 from pyverbs.pyverbs_error import PyverbsError
-from pyverbs.tests.base import PyverbsAPITestCase
-import pyverbs.tests.utils as u
+from tests.base import PyverbsAPITestCase
 import pyverbs.enums as e
+import tests.utils as u
 
 
 class CQTest(PyverbsAPITestCase):
diff --git a/pyverbs/tests/device.py b/tests/test_device.py
similarity index 99%
rename from pyverbs/tests/device.py
rename to tests/test_device.py
index 63f195156119..e395e793c28f 100644
--- a/pyverbs/tests/device.py
+++ b/tests/test_device.py
@@ -8,8 +8,8 @@ import resource
 import random
 
 from pyverbs.pyverbs_error import PyverbsError, PyverbsRDMAError
-from pyverbs.tests.base import PyverbsAPITestCase
-import pyverbs.tests.utils as u
+from tests.base import PyverbsAPITestCase
+import tests.utils as u
 import pyverbs.device as d
 
 PAGE_SIZE = resource.getpagesize()
diff --git a/pyverbs/tests/mr.py b/tests/test_mr.py
similarity index 99%
rename from pyverbs/tests/mr.py
rename to tests/test_mr.py
index 4be3987fc18b..e87fb33624ed 100644
--- a/pyverbs/tests/mr.py
+++ b/tests/test_mr.py
@@ -7,13 +7,13 @@ from itertools import combinations as com
 import random
 
 from pyverbs.pyverbs_error import PyverbsRDMAError, PyverbsError
-from pyverbs.tests.base import PyverbsAPITestCase
+from tests.base import PyverbsAPITestCase
 from pyverbs.base import PyverbsRDMAErrno
 from pyverbs.mr import MR, MW, DMMR
-import pyverbs.tests.utils as u
 import pyverbs.device as d
 from pyverbs.pd import PD
 import pyverbs.enums as e
+import tests.utils as u
 
 MAX_IO_LEN = 1048576
 
diff --git a/pyverbs/tests/pd.py b/tests/test_pd.py
similarity index 97%
rename from pyverbs/tests/pd.py
rename to tests/test_pd.py
index 87528db7d437..978cf4900146 100644
--- a/pyverbs/tests/pd.py
+++ b/tests/test_pd.py
@@ -5,7 +5,7 @@ Test module for pyverbs' pd module.
 """
 import random
 
-from pyverbs.tests.base import PyverbsAPITestCase
+from tests.base import PyverbsAPITestCase
 from pyverbs.base import PyverbsRDMAErrno
 import pyverbs.device as d
 from pyverbs.pd import PD
diff --git a/pyverbs/tests/qp.py b/tests/test_qp.py
similarity index 99%
rename from pyverbs/tests/qp.py
rename to tests/test_qp.py
index bbf28244f641..1ce98388871b 100644
--- a/pyverbs/tests/qp.py
+++ b/tests/test_qp.py
@@ -5,12 +5,12 @@ Test module for pyverbs' qp module.
 """
 import random
 
-from pyverbs.tests.base import PyverbsAPITestCase
 from pyverbs.qp import QPInitAttr, QPAttr, QP
-import pyverbs.tests.utils as u
+from tests.base import PyverbsAPITestCase
 import pyverbs.enums as e
 from pyverbs.pd import PD
 from pyverbs.cq import CQ
+import tests.utils as u
 
 
 class QPTest(PyverbsAPITestCase):
diff --git a/pyverbs/tests/utils.py b/tests/utils.py
similarity index 100%
rename from pyverbs/tests/utils.py
rename to tests/utils.py